# -*- coding: utf-8 -*-
"""
    MoinMoin - SMSCOIN Key

    This plugin restrict access to moinmoin pages content by key. User can receive key by sending SMS. You can specify, how long and/or how much user can access restricted content.


    SMSCOIN Key
    @copyright: 2008 SMSCOIN
"""

from MoinMoin import wikiutil
from MoinMoin.util.header import Header

import urllib, urllib2


Dependencies = []

class Parser:
    """Secure content with smskey (smscoin.com)"""
    
    Dependencies = []


    def __init__(self, raw, request, **kw):
        self.raw = raw
        self.request = request
        self.form = request.form
        self._ = request.getText

    def _get_formatterName(self, formatter):
        import inspect
        for key, value in inspect.getmembers(formatter, inspect.isclass(formatter)):
            if key == '__module__':
                return value
        return ''

    def format(self, formatter):
        """ Send the text. """
        _ = self._
        self.header = Header(self.request, self.raw)

        try:

            params = {'s_key' : int(self.header.get('key_id', 0)),
                      's_language' :  self.header.get('s_language', ''),
                      's_pair' :  self.request.args.get('s_pair', [''])[0],
                      's_ip' :  self.request.remote_addr,
                      's_url' :  "%s%s" % (self.request.http_host, self.request.request_uri),
                      's_pure' : 1,
                      's_enc' : 'utf-8',
                      }
        
            data_ok = True
        except Exception, message:
            data_ok = False
            error = "%s: %s" % (Exception, message)
            

        if (data_ok):
            opener = urllib2.Request("http://service.smscoin.com/key/?%s" % urllib.urlencode(params),
                                     headers = {'User-agent': 'smscoin_key_1.0.6'})
            
            try:
                response = urllib2.urlopen(opener).read()
                pass
            except:
                error = 'Can\'t connect to remote service to check key.'
                response = ""
                
            if (response[:4] == 'true'):
                # достаём обычный wiki-парсер
                Parser = wikiutil.importPlugin(self.request.cfg, 'parser', 'text_moin_wiki', 'Parser')
                # скармливаем содержимое блока, кроме заголовка с key_id и s_language
                wiki_parser = Parser(self.raw[self.header.length():], self.request)
                
                if self._get_formatterName(formatter) == 'MoinMoin.formatter.text_html':
                    wiki_parser.format(formatter)
                else:
                    self.request.write(formatter.text(_('Restricted content is available only in html-version page.')))
            else:
                self.request.write(formatter.rawHTML(response.decode('utf-8')))
                pass

            
        else:
            self.request.write(formatter.text(_('Error retreiving data: ') + error))

            
